/* Definitions for Samtools.  Version 1.2, 22 March 1996 */

#include<string.h>
#include<stdio.h>

#define ENVVAR        "SAMDISKFILE"
#define SLASHVAR      "SAMSEPARATOR"
#define DIRVAR        "SAMDIR"
#define DEVICE        "/dev/rfd0"
#define DIR_TRACKS    4
#define DIR_PER_TRACK 20
#define RESERVED      80
#define DIR_LEN       256
#define MAP_LEN       196
#define NAME_LEN      10
#define SECTOR_LEN    512
#define SECTORS       10
#define NCYL          80
#define NBLK          (2*NCYL*SECTORS)
#define FREE          (NBLK-80/(SECTOR_LEN/DIR_LEN))
#define EOF_MAGIC     -123
#define TRACK(s)      (((s)<SECTORS*NCYL)?((s)/SECTORS):((s)/SECTORS+48))
#define SECTOR(s)     (1+(s)%SECTORS)
#define MATCHES       20

typedef unsigned char dir_entry[DIR_LEN];
extern unsigned char map[MAP_LEN];
extern dir_entry *directory;
extern unsigned char *matched;
extern struct _matchinfo {char t,x,y;} matchinfo[MATCHES];
extern int diskfree;
extern char *progname;
extern char *device;
extern int Mdos;
extern int dirno;
extern int ign_dirno;
extern int dir_entries;
extern char slash;

#ifdef __STDC__
#define Args(a) a
#else
#define Args(a) ()
#endif

int samdir Args((char *mode));
void findsector Args((int fd,int sector));
void samerror Args((char *msg,char *name));
int match Args((char *pattern,char *name));
int matchup Args((int argc, char**argv,int flag));
int nameseq Args((char *s1,char *s2));
unsigned char *makename Args((char *name));
void printname Args((char *name,FILE *stream));
int finddir Args((char *name, int flag));

#define getname() ((((progname=strrchr(argv[0],'/')))&&(progname++))\
                   ||(progname=argv[0]),\
                   argc>2&&!strncmp(argv[1],"-disk",5)&&\
                      (device=argv[2],argv+=2,argc-=2))
