/* The commands "samdiskread" and "samdiskwrite" (see accompanying manual).
   Version 1.2, 22 March 1996. */

#include"sam.h"
#include<stdio.h>
#include<fcntl.h>
#include<sys/types.h>
#include<errno.h>

#ifdef SUN_DKIO
#include<sun/dkio.h>
#endif

char buffer[SECTORS*2*SECTOR_LEN];

main(argc,argv)
int argc;
char **argv;
{
   char *getenv();
   int f,g,h,i,r;
   int isread;
#ifdef SUN_DKIO
   struct fdk_char cha;
   struct dk_map dmap;
#endif
   getname();
   isread=!strchr(progname,'w');
   if(!device)device=getenv(ENVVAR);
   if(!device)device=DEVICE;
   if(argc>2){
      fprintf(stderr,"%s: too many parameters (only a file name is required)",
         progname);
      exit(1);
   }
   f=open(device,isread ? O_RDONLY : O_RDWR);
   if(f<0)samerror("Couldn't open",device);
   if(argc>1)
      g=open(argv[1],isread ? O_CREAT|O_TRUNC|O_WRONLY : O_RDONLY, 0644);
   else g=isread ? 1 : 0;
   if(g<0)samerror("Couldn't open",argv[1]);

#ifdef SUN_DKIO
   if(ioctl(f,FDKIOGCHAR,&cha))
      fprintf(stderr,"%s: warning: couldn't access device parameters on %s\n",
         progname,device);
   else {
      if(ioctl(f,DKIOCGPART,&dmap))
         samerror("Error from get-partition ioctl on",device);
      cha.secptrack=SECTORS; cha.ncyl=NCYL;
      dmap.dkl_nblk=NBLK;
      if(ioctl(f,FDKIOSCHAR,&cha))
         samerror("Error from set-characteristics ioctl on",device);
      if(ioctl(f,DKIOCSPART,&dmap))
         samerror("Error from set-partition ioctl on",device);
   }
#else
   fprintf(stderr,"%s: warning: this program is not configured to set device parameters\n",
           progname);
#endif

   if(!isread)i=f,f=g,g=i;

   i=NBLK*SECTOR_LEN;
   while(i>0){
      h=sizeof buffer;
      if(h>i)h=i;
      r=read(f,buffer,h);
      if(r==0)errno=EOF_MAGIC;
      if(r<=0)samerror("Error while reading data","");
      i-=r;
      h=write(g,buffer,r);
      if(h>=0)errno=EOF_MAGIC;
      if(h<r)samerror("Error while writing data","");
   }
   close(f);close(g);
   return 0;
}
