/* The command "samlabel" (see accompanying manual).
   Version 1.2, 29 March 1996. */
#include"sam.h"
#include<fcntl.h>
#include<sys/types.h>
#include<errno.h>
#include<unistd.h>

#ifdef SUN_DKIO
#include<sun/dkio.h>
#endif

unsigned char buffer[512];

main(argc,argv)
int argc;
char **argv;
{
   char *getenv();
#ifdef SUN_DKIO
   struct fdk_char cha;
   struct dk_map dmap;
#endif
   int f,i,r;
   int tracks=-1;
   getname();
   if(!device)device=getenv(ENVVAR);
   if(!device)device=DEVICE;
   if(argv[1][0]=='-'){
      tracks=atoi(argv[1]+1);
      if(tracks<4 || tracks>39){
         fprintf(stderr,"%s: tracks must be between 4 and 39.\n",progname);
         exit(1);
      }
      argv++,argc--;
   }
   if(argc>2){
      fprintf(stderr,"%s: too many parameters (only a disk name is required).\n",
         progname);
      exit(1);
   }
   /* Here we go, standard disk opening routine */
   f=open(device,O_RDWR);
   if(f<0)samerror("Couldn't open",device);
#ifdef SUN_DKIO
   if(!ioctl(f,FDKIOGCHAR,&cha)){
      if(ioctl(f,DKIOCGPART,&dmap))
         samerror("Error from get-partition ioctl on",device);
      cha.secptrack=SECTORS; cha.ncyl=NCYL;
      dmap.dkl_nblk=NBLK;
      if(ioctl(f,FDKIOSCHAR,&cha))
         samerror("Error from set-characteristics ioctl on",device);
      if(ioctl(f,DKIOCSPART,&dmap))
         samerror("Error from set-partition ioctl on",device);
   }
#endif
   r=read(f,buffer,512);
   if(r>=0)errno=EOF_MAGIC;
   if(r<512)samerror("Error while reading data from",device);
   if(tracks>=4){
      if(buffer[0] || buffer[1])
         fprintf(stderr,"%s: cannot change directory tracks: disk has been used.\n",
            progname);
      else buffer[255]=tracks-4;
   }
   if(buffer[255]>35)buffer[255]=0;
   if(!buffer[252] && !buffer[253]){
      r=getpid();
      r=(75*r)%65537-1;
      if(r<1)r=74;
      buffer[252]=r%256;
      buffer[253]=r/256;
   }
   if(argc>1){
      for(i=0;i<10&&argv[1][i];i++)buffer[210+i]=argv[1][i];
      while(i<10)buffer[210+i++]=' ';
   }
   else if(buffer[210]<32)memcpy(buffer+210,"MASTERDOS ",10);
   if(lseek(f,0,SEEK_SET)<0)samerror("Error during lseek on",device);
   r=write(f,buffer,512);
   if(r>=0)errno=EOF_MAGIC;
   if(r<512)samerror("Error while writing data to",device);
   close(f);
   return 0;
}
