/* The commands "samread", "samtype" (see accompanying manual).
   Version 1.2, 22 March 1996 */
#include"sam.h"
#include<fcntl.h>
#include<sys/types.h>
#include<unistd.h>

#define entry directory[d]
#define treek(x) ((entry[x]&0x1f)*16384+entry[(x)+1]+\
                 (entry[(x)+2]&0x3f)*256)

#define used matched /* unsigned char used[dir_entries] */
void read2();
static unsigned char track[SECTORS][SECTOR_LEN];
static int trk;

main(argc,argv)
int argc;
char **argv;
{
   static unsigned char sector2[512];
   static unsigned char name[11];
   static char path[1024];
   int pathlen;
   char *basename;
   int x,f,d,i,a,k,l,L,m,n,F,B,S,ifstar,of,text=0,ttext,var=0,tvar,
       found,print,noh,curdir;
   getname();
   print=!strcmp(progname,"samtype");
   if(argc<2)fprintf(stderr,"%s: Please supply a file name\n",progname),exit(1);
   f=samdir("r");
   curdir=dirno;
   for(a=1;a<argc;a++){
      if(!strcmp(argv[a],"-t")){text=1;continue;}
      if(!strcmp(argv[a],"-b")){text=0;continue;}
      if(!strcmp(argv[a],"-var")){var=1;continue;}
      if(!strcmp(argv[a],"-all")){ign_dirno=1;continue;}
      if(!strcmp(argv[a],"-dir")){
         if(!Mdos){
            fprintf(stderr,"%s: %s is not a MasterDOS disk\n",
               progname,device);
            exit(1);
         }
         a++;
         if(a==argc){
            fprintf(stderr,"%s: -dir requires an argument\n",progname);
            exit(1);
         }
         curdir=finddir(argv[a],1);
         ign_dirno=0;
         continue;
      }
      if(!strcmp(argv[a],"-file")&&a+1<argc)a++;
      if((basename=strrchr(argv[a],'/')))basename++;
      else basename=argv[a];
      if((pathlen=basename-argv[a]))memcpy(path,argv[a],pathlen);
      found=0;
      for(d=0;d<dir_entries;d++){
         if(d==RESERVED)d+=2;
         ttext=text; tvar=var;
         if(!entry[0] || !match(basename,entry+1))continue;
         if(Mdos && !ign_dirno && entry[254]!=curdir)continue;
         found=1;
         memcpy(name,entry+1,NAME_LEN);
         for(n=NAME_LEN-1;n>0&&name[n]==' ';n--);
         name[n+1]=0;
         strcpy(path+pathlen,name);
         if((entry[0]&63)==21){
            fprintf(stderr,"%s: can't read %s: is a directory\n",
               progname,name);
            continue;
         }
         if(print)F=1;
         else F=open(path,O_WRONLY|O_CREAT|O_TRUNC,0644);
         if(F<0)samerror("Couldn't open",path),exit(1);
         noh=0;
         switch(entry[0]&63){
         case 5:  printf("%s: ZX Snap 48\n",name);
                  tvar=ttext=0;
                  noh=1;
                  if(write(F,entry+220,22)<22)
                     samerror("Couldn't write to",name);
                  break;
         case 10: if(!print)printf("%s: OPENTYPE\n",name);
                  tvar=0;
                  noh=1;
                  break;
         case 16: printf("%s: Basic",name);
                  if(entry[242]<255)
                     printf(", LINE %d",treek(242));
                  printf("\nProgram length: %d\n",treek(221));
                  printf("Program + numv: %d\n",treek(224));
                  printf("Program + gap:  %d\n",treek(227));
                  tvar=ttext=0;
                  break;
         case 17: printf("%s: Number array %*s\n",name,
                          entry[221]&15,entry+222);
                  tvar=ttext=0;
                  break;
         case 18: if(!print || !tvar)
                     printf("%s: String array %*s\n",name,
                             entry[221]&15,entry+222);
                  if(!tvar)ttext=0;
                  break;
         case 19: if(!print){
                     printf("%s: Code %d,%d",name,
                             treek(236)+16384,treek(239));
                     if(entry[242]<255)
                        printf(",%d",treek(242)+16384);
                     putchar('\n');
                  }
                  tvar=0;
                  break;
         case 20: printf("%s: Screen picture (mode %d)\n",
                         name,entry[221]+1);
                  tvar=ttext=0;
                  break;
         default: printf("%s: Unknown type",name);
                  tvar=0;
                  noh=1;
         }
         B=l=treek(239);
         if((entry[0]&63)==5){
            l=entry[11]*256+entry[12];
            if(l>=97)B=l=49152;
            else B=l=510*l,
                 fprintf(stderr,"%s: %s is probably not a Sam snap file\n",
                         progname,name);
         }
         for(n=15,S=40;l && n<221;n++){
            m=entry[n];
            for(k=0;l && k<8;k++,S++){
               if(m&1){
                  read2(f,S,sector2);
                  if(l==B && !noh){
                     of=9;
                     if(tvar)of+=14,l-=14;
                  }
                  else of=0;
                  if(l>=510-of)L=510-of; else L=l;
                  if(ttext){
                     if(L==l && sector2[of+L-1]==255)l--,L--;
                     for(x=of;x<510;x++)
                        if(sector2[x]==13)sector2[x]=10;
                  }
                  if(write(F,sector2+of,L)<L)
                     samerror("Couldn't write to",path);
                  l-=L;
               }
               m>>=1;
            }
         }
         if(!print){
            close(F);
            printf("%d bytes read.\n",B);
         }
      }
      if(!found)fprintf(stderr,"%s: %s not found.\n",progname,basename);
      var=0;
   }
   close(f);
   exit(0);
}

void read2(f,s,buff)
int f,s;
unsigned char *buff;
{
   int sct=s%10;
   int l,r;
   static char msg[80];
   unsigned char *p;
   if((s/SECTORS)!=trk){
      trk=s/SECTORS;
      p=track[sct];
      l=(SECTORS-sct)*SECTOR_LEN;
      findsector(f,s);
      while(l>0){
         r=read(f,p,l);
         if(r<0){
            sct=trk*SECTORS+(p-track[0])/SECTOR_LEN;
            sprintf(msg,"track %d, sector %d",TRACK(sct),SECTOR(sct));
            samerror("Read failed at",msg);
         }
         if(r==0)fprintf(stderr,"%s: Unexpected EOF while reading track %d\n",
                         progname,trk),exit(1);
         l-=r; p+=r;
      }
   }
   memcpy(buff,track[s%10],512);
}
