/* The command "samsnap" (see accompanying manual).
   Version 1.2, 22 March 1996. */
#include <fcntl.h>
#include<sys/types.h>
#include<unistd.h>
#include<sys/stat.h>
#include<memory.h>
#include<stdio.h>
#include<errno.h>

typedef unsigned char byte;
struct _sna {
        byte i,
             hl1[2],de1[2],bc1[2],af1[2],
             hl[2],de[2],bc[2],iy[2],ix[2],
             iff,r,
             af[2],sp[2],
             im,border;
        } sna;

struct _samsnap {
        byte iy[2],ix[2],de1[2],bc1[2],hl1[2],af1[2],
             de[2],bc[2],hl[2],
             spare,i,
             sp[2];
        } samsnap;

byte dump[49152];

char *progname;

struct stat statbuf;

#define tosam2(reg) (samsnap.reg[0]=sna.reg[0],samsnap.reg[1]=sna.reg[1])
#define fromsam2(reg) (sna.reg[0]=samsnap.reg[0],sna.reg[1]=samsnap.reg[1])

main(argc,argv)
int argc;
char **argv;
{
   char *f1=argv[1];
   char *f2=argv[2];
   int fd1,fd2;
   int len;
   int sp;
   progname=argv[0];
   if(argc<2||argc>3)
      fprintf(stderr,"usage: %s file1 [file2]\n",progname),exit(1);
   if(stat(f1,&statbuf))anerror("couldn't stat",f1);
   len=statbuf.st_size;
   if(len!=49174 && len !=49179 && len!=65536){
      fprintf(stderr,"%s: %s has incorrect length of %d\n",progname,f1,len);
      exit(1);
   }
   if((fd1=open(f1,O_RDONLY))<0)anerror("couldn't open",f1);
   if(argc==2)fd2=1,f2="stdout";
   else if((fd2=open(f2,O_CREAT|O_TRUNC|O_WRONLY,0644))<0)
      anerror("couldn't open",f2);
   if(len==49174 || len==65536){
      fputs("Writing .SNA file\n",stderr);
      if(len==49174) /* Samsnap has the registers at the start */
         if(read(fd1,(char*)&samsnap,22)<22)anerror("couldn't read",f1);
         else /* nop */;
      else { /* Messenger has the registers near the end of the ROM */
         if(read(fd1,(char*)dump,0x3d00-22)<0x3d00-22
         || read(fd1,(char*)&samsnap,22)<22
         || read(fd1,(char*)dump,0x300)<0x300)
            anerror("couldn't read",f1);
      }
      if(read(fd1,(char*)dump,49152)<49152)anerror("couldn't read",f1);
      sp=samsnap.sp[0]+256*samsnap.sp[1]-16384;
      sna.iff=(dump[sp++]&4)?255:0;
      sna.r=dump[sp++];
      sna.af[0]=dump[sp++];
      sna.af[1]=dump[sp++];
      sp+=16384;
      sna.sp[0]=sp%256;
      sna.sp[1]=sp/256;
      sna.border=0;
      sna.im=samsnap.i==0||samsnap.i==63?1:2;
      sna.i=samsnap.i;
      fromsam2(hl1);
      fromsam2(de1);
      fromsam2(bc1);
      fromsam2(af1);
      fromsam2(hl);
      fromsam2(de);
      fromsam2(bc);
      fromsam2(iy);
      fromsam2(ix);
      if(write(fd2,(char*)&sna,27)<27)anerror("couldn't write",f2);
   }
   else{
      fputs("Writing Sam snap file\n",stderr);
      if(read(fd1,(char*)&sna,27)<27)anerror("couldn't read",f1);
      if(read(fd1,(char*)dump,49152)<49152)anerror("couldn't read",f1);
      sp=sna.sp[0]+256*sna.sp[1]-16384;
      dump[--sp]=sna.af[1];
      dump[--sp]=sna.af[0];
      dump[--sp]=sna.r;
      dump[--sp]=sna.iff;
      sp+=16384;
      samsnap.sp[0]=sp%256;
      samsnap.sp[1]=sp/256;
      samsnap.spare=0;
      samsnap.i=sna.i;
      tosam2(hl1);
      tosam2(de1);
      tosam2(bc1);
      tosam2(af1);
      tosam2(hl);
      tosam2(de);
      tosam2(bc);
      tosam2(iy);
      tosam2(ix);
      if(write(fd2,(char*)&samsnap,22)<22)anerror("couldn't write",f2);
   }
   if(write(fd2,(char*)dump,49152)<49152)anerror("couldn't write",f2);
   close(fd1);
   close(fd2);
   exit(0);
}

anerror(msg,name)
char *msg, *name;
{
   extern char *sys_errlist[];
   extern int sys_nerr;
   char *sysmsg;
   if(errno<0||errno>sys_nerr)sysmsg="Unknown error occurred";
   else sysmsg=sys_errlist[errno];
   fprintf(stderr,"%s: %s %s: %s\n",progname,msg,name,sysmsg);
   exit(1);
}
