/* The command "samwrite" (see accompanying manual).
   Version 1.2, 22 March 1996. */
#include"sam.h"
#include <fcntl.h>
#include<sys/types.h>
#include<unistd.h>
#include<sys/stat.h>
#include<memory.h>

#define entry directory[d]
#define troke(x,y) (entry[x]=(y)/16384,entry[(x)+1]=(y)%256,\
                    entry[(x)+2]=((y)/256)&0x3f)
#define troke2(x,y) (entry[x]=(y)/16384,entry[(x)+1]=(y)%256,\
                    entry[(x)+2]=(((y)/256)&0x3f)|0x80)
#define copy(x,y)  (entry[x]=entry[y])

void findsector2(),write2(),flush2();

static unsigned char track[SECTORS][SECTOR_LEN];
static unsigned char used[SECTORS];
static int sct=0;

main(argc,argv)
int argc;
char **argv;
{
   static unsigned char sector2[512];
   static unsigned char *name;
   int f,d,a,i,j,l,L,F,n,S,m,M,k,of;
   int addr,len,exec,type,numvars,numend,savars,sectors;
   int over=0,erase,text=0,ttext,string,prot=0,mode=0,mkdir=0;
   static char array[11];
   struct stat statbuf;
   int curdir;

   getname();
   if(argc<2)puts("Please supply a file name"),exit(1);

   f=samdir("w");
   curdir=dirno;
   for(a=1;a<argc;a++){
      type=19,addr=-1,exec=-1,string=mkdir=0,ttext=text;
      while(a<argc&&argv[a][0]=='-'){
         if(!strcmp(argv[a],"-basic")){
            if(++a+3>argc)puts("-basic has three arguments"),exit(1);
            numvars=atoi(argv[a++]);
            numend=atoi(argv[a++]);
            savars=atoi(argv[a++]);
            if(!numvars||!numend||!savars||
               numvars>numend || numend>savars)
               perror("invalid parameters for -basic"),exit(1);
            if(addr<0)addr=23770;
            type=16;
            ttext=0;
            string=0;
         }
         else if(!strcmp(argv[a],"-exec")){
            if(++a+1>argc)puts("-exec has an argument"),exit(1);
            exec=atoi(argv[a++]);
            if(addr<0)addr=exec;
         }
         else if(!strcmp(argv[a],"-addr")){
            if(++a+1>argc)puts("-addr has an argument"),exit(1);
            addr=atoi(argv[a++]);
         }
         else if(!strcmp(argv[a],"-string")){
            if(++a+1>argc)puts("-string has an argument"),exit(1);
            array[0]=strlen(argv[a]);
            strncpy(array+1,argv[a++],10);
            if(array[0]>10|array[0]==0)
               puts("String should have length 1 to 10"),exit(1);
            if(addr<0)addr=0x6f00;
            type=18;
            string=1;
         }
         else if(!strcmp(argv[a],"-mode")){
            if(++a+1>argc)puts("-mode has an argument"),exit(1);
            mode=atoi(argv[a++]);
            if(mode<1 || mode>4)
               puts("-mode must be between 1 and 4"),exit(1);
            else mode--;
         }
         else if(!strcmp(argv[a],"-screen")){
            type=20;
            if(++a+1>argc)puts("-screen has an argument"),exit(1);
            mode=atoi(argv[a++]);
            if(mode<1 || mode>4)
               puts("-screen must be between 1 and 4"),exit(1);
            else mode--;
         }
         else if(!strcmp(argv[a],"-dir")){
            if(++a+1>argc)puts("-dir has an argument"),exit(1);
            if(!Mdos){
               fprintf(stderr,"%s: %s is not a MasterDOS disk\n",
                  progname,device);
               exit(1);
            }
            curdir=finddir(argv[a++],1);
         }
         else if(!strcmp(argv[a],"-mkdir")){
            mkdir=1;
            type=21;
            a++;
            if(!Mdos){
               fprintf(stderr,"%s: %s is not a MasterDOS disk\n",
                  progname,device);
               exit(1);
            }
         }
         else if(!strcmp(argv[a],"-var")){
            type=18;
            ttext=0;
            a++;
         }
         else if(!strcmp(argv[a],"-snap")){
            type=5;
            ttext=0;
            addr=16384;
            a++;
         }
         else if(!strcmp(argv[a],"-over")){
            a++;
            over=1;
         }
         else if(!strcmp(argv[a],"-prot")){
            a++;
            prot=128;
         }
         else if(!strcmp(argv[a],"-unprot")){
            a++;
            prot=0;
         }
         else if(!strcmp(argv[a],"-t")){
            a++;
            text=ttext=1;
         }
         else if(!strcmp(argv[a],"-b")){
            a++;
            text=ttext=0;
         }
         else if(!strcmp(argv[a],"-file")){
            a++;
            break;
         }
         else fprintf(stderr,"%s: Unrecognised option %s\n",
                            progname,argv[a]),exit(1);
      }
      if(a==argc)fprintf(stderr,"%s: Missing file name\n",progname),exit(1);
      name=makename(argv[a]);
      if(mkdir){
         l=dirno;
         dirno=curdir;
         mkdir=finddir(argv[a],0);
         dirno=l;
         len=sectors=0;
      }
      else {
         mkdir--;
         if(stat(argv[a],&statbuf))
            samerror("Couldn't stat",argv[a]);
         if(!S_ISREG(statbuf.st_mode))
            fprintf(stderr,"%s: %s is not a regular file\n",progname,argv[a]),
            exit(1);
         len=statbuf.st_size;
         if(type==5&&len!=49174)
            fprintf(stderr,"%s: %s is probably not a Sam snap file\n",progname,argv[a]);
         if(type==5 && (len-=22)<=0)exit(1);
         sectors=(len+518+string*14+text)/510;
      }
      erase=0;
      for(d=0;d<dir_entries;d++){
         if(d==RESERVED)d+=2;
         if(entry[0] && nameseq(entry+1,name) &&
              (!Mdos || entry[254]==curdir)){
            if(!over){
               printname(entry+1,stdout);
               fputs(" exists - overwrite? [y/n] ",stdout);
               fflush(stdout);
               fgets(sector2,512,stdin);
               if((sector2[0]&0xdf)!='Y')goto nextarg;
            }
            erase=1;
            break;
         }
      }
      if(d==dir_entries){
         for(d=0;d<dir_entries&&entry[0];d++)
            if(d==RESERVED-1)d+=2;
         if(d==dir_entries)fprintf(stderr,"%s: Directory full\n",progname),
            exit(1);
      }
      memcpy(entry+1,name,10);
      findsector(f,d/2);
      if(erase){
         for(j=0;j<196;j++)map[j]&=~entry[j+15];
         diskfree+=entry[11]*256+entry[12];
      }
      if(sectors>diskfree)
         fprintf(stderr,"%s: Disk full - only %d sectors left\n",
            progname,diskfree),exit(1);
      printf("Writing %10s\n",name);
      if(Mdos && d==0)memset(entry,0,210);
      else memset(entry,0,256);
      entry[0]=type|prot;
      memcpy(entry+1,name,10);
      if(mkdir>=0){
         entry[254]=mkdir;
         mkdir=0;
         for(l=0;l<dir_entries;l++){
            if(l==RESERVED)l+=2;
            if((directory[l][0]&63)==21)
               if(directory[l][250]>mkdir)mkdir=directory[l][250];
         }
         entry[250]=mkdir+1;
      }
      else{
         entry[11]=sectors/256;
         entry[12]=sectors%256;
         if(addr<16384)addr=32768;
         troke2(236,addr-16384);
         troke(239,len+string*14+text);
         if(exec>=0 && type==19)troke2(242,exec-16384);
         else if(exec>=0)troke(242,exec);
         else entry[242]=entry[243]=entry[244]=255;
         memset(entry+245,255,7);
         memset(entry+232,255,4);
         entry[254]=Mdos ? curdir : 0;
         entry[220]=32;
         if(type==16){
            troke(221,numvars);
            troke(224,numend);
            troke(227,savars);
         }
         else if(string)memcpy(entry+221,array,11);
         else entry[221]=mode;
         if(!Mdos || d){
            copy(211,0);
            copy(212,240);
            copy(213,241);
            copy(214,237);
            copy(215,238);
            copy(216,242);
            copy(217,243);
            copy(218,239);
            copy(219,242);
         }
         l=len+text;
         if((F=open(argv[a],O_RDONLY))<0)
            samerror("Couldn't open",argv[a]);
         if((type==17||type==18)&&!string){
            if(read(F,entry+221,11)<11)samerror("Couldn't read",argv[a]);
            if(lseek(F,0,SEEK_SET)<0)samerror("Couldn't rewind",argv[a]);
         }
         else if(type==5){/* the first 22 bytes belong in the header, not
                             the file */
            if(read(F,entry+220,22)<22)samerror("Couldn't read",argv[a]);
         }
         for(n=0,S=40;l && n<196;n++){
            m=map[n];
            M=1;
            for(k=0;k<8 && (m&M);k++,S++,M<<=1);
            if(k<8)break;
         }
         entry[15+n]|=M;
         m=map[n]|=M;
         entry[13]=TRACK(S);
         entry[14]=SECTOR(S);
         sct=0;
         while(l){
            if(l>=len && type!=5){
               memcpy(sector2,entry+211,of=9);
               if(string){
                  memcpy(sector2+9,array,11);
                  sector2[20]=l/16384;
                  sector2[21]=l%256;
                  sector2[22]=((l/256)&0x3f);
                  of+=14;
               }
            }
            else of=0;
            if(l>=510-of)L=510-of; else L=l-text;
            if(read(F,sector2+of,L)!=L)samerror("Couldn't read",argv[1]);
            if(text)for(j=of;j<510;j++)if(sector2[j]==10)sector2[j]=13;
            l-=L;
            if(text && l==1 && L<510-of)sector2[L+of]=255,l--;
            findsector2(f,S);
            if(l){
               while(m&M){
                  S++;
                  if(k<7)k++,M<<=1;
                  else k=0,M=1,m=map[++n];
               }
               entry[15+n]|=M;
               m=map[n]|=M;
               sector2[510]=TRACK(S);
               sector2[511]=SECTOR(S);
            }
            else sector2[510]=sector2[511]=0;
            write2(sector2);
            diskfree--;
         }
         flush2(f);
         close(F);
      }
      findsector(f,d/2);
      if(write(f,directory[(d/2)*2],512)<512)
         samerror("Couldn't write to",device);
nextarg: continue;
   }
   close(f);
   exit(0);
}

void findsector2(f,s)
int f,s;
{
   if((s/SECTORS)!=(sct/SECTORS))flush2(f);
   sct=s;
}

void write2(sector)
unsigned char*sector;
{
   int s=sct%SECTORS;
   used[s]=1;
   memcpy(track[s],sector,SECTOR_LEN);
}

void flush2(f){
   int i,j;
   int l;
   int w;
   unsigned char *p;
   static char msg[80];
   int t=sct/SECTORS;
   for(i=0;i<SECTORS;i++){
      if(!used[i])continue;
      p=track[i];
      for(j=i+1;j<SECTORS&&used[j];j++);
      l=SECTOR_LEN*(j-i);
      findsector(f,t*SECTORS+i);
/*    fprintf(stderr,"Writing track %d, sectors %d-%d...",t,i,j-1);
      fflush(stderr);    */
      while(l>0){
/*       fprintf(stderr,"%d...",l);  */
         w=write(f,p,l);
         if(w<=0){
            sct=t*SECTORS+(p-track[0])/SECTOR_LEN;
            sprintf(msg,"track %d, sector %d",TRACK(sct),SECTOR(sct));
            samerror("Write failed at",msg);
         }
         l-=w;
         p+=w;
      }
      i=j;
/*    fputs("Done\n",stderr);          */
   }
   for(i=0;i<SECTORS;i++)used[i]=0;
}

